#!/bin/sh
#
# devto.sh -- find the ethernet device to a destination
#
# USAGE: devto.sh <destination>
#
# You can use a hostname or an IP address as destination.
# The destination does not have to be directly connected
# to the local host; it just needs to be routable.
#

# set -x

if [ -z "$1" ]; then
        echo "error: no destination"
        echo "USAGE: devto.sh <destination-IP-or-hostname>"
        echo
        exit 1
fi

name=$1
ip=`gethostip $name | awk '{print $2}'`
route=`ip route get $ip | grep dev`
dev=`echo $route | sed 's/^.* dev //' | awk '{print $1}'`

echo $dev
