#ifndef _PKTRAIN_H
#define _PKTRAIN_H

#define PKTRAIN_ONEWAY	0
#define PKTRAIN_PING	(1<<0)
#define PKTRAIN_PONG	(1<<1)
#define PKTRAIN_FIRST   (1<<2)
#define PKTRAIN_LAST    (1<<3)

struct pktrain_payload {
	char tag[4];
	int type;
	struct timeval tstamp;
	struct timeval tstamp_ping;
	int count;
        int order;
        int gap_usec;
        int pkts_in_train;
	int count_ping;
};

static inline void
pktrain_print_pd(const struct pktrain_payload *pd)
{
	printf("[%s] %d tag %s count %d gap %d pkts %d tstamp %ld.%.6ld count2 %d tstamp2 %ld.%.6ld",
		(pd->type == PKTRAIN_ONEWAY 	? "oneway"	:
		 pd->type == PKTRAIN_PING 	? "ping"	:
		 pd->type == PKTRAIN_PONG 	? "pong"	:
		 				  "unknown"),

                pd->order,
		pd->tag,
		pd->count,
		pd->gap_usec,
		pd->pkts_in_train,
		pd->tstamp.tv_sec, pd->tstamp.tv_usec,
		pd->count_ping,
		pd->tstamp_ping.tv_sec, pd->tstamp_ping.tv_usec);
}

#endif
