#!/bin/sh
#
# Script that generates fixed-rate cross traffic with variable-sized packets
#   uses tcpreplay and traffic snapshot of Japan-U.S. link from 
# 
# http://mawi.wide.ad.jp/
#  http://mawi.wide.ad.jp/mawi/
#   http://mawi.wide.ad.jp/mawi/samplepoint-F/20080318/
#    http://mawi.wide.ad.jp/mawi/samplepoint-F/20080318/200803201500.html
#     ftp://mawi.nezu.wide.ad.jp/pub/mawi/samplepoint-F/20080318/200803201500.dump.gz
#
# USAGE replay.sh <src> <dst> <duration>
#
# Must be run from the current directory. WILL NOT WORK if (src != c1) and (dst != c2)
#

set -o nounset
src=$1
dst=$2
duration=$3

steps_mbps="1 3 5 6 4 2"
stepnum=`echo $steps_mbps | wc -w`

tcpreplay="sudo /proj/MediaNet/tagent/jmccann/tagent/tools/bin/tcpreplay -i `devto x1` "
replayfile="/proj/MediaNet/tagent/jmccann/traces/jp-us.rewritten.c1-x1-c2.line-cross3.pcap.split.0.fixed"

stepduration=`echo "$duration/$stepnum" | bc -l | awk -F. '{print $1}'`

# # remove any current cross traffic session
# $trafgen -P$src,$dst -z

# # start a new traffic session (no traffic yet)
# $trafgen -P$src,$dst -c

# generate traffic steps
for mbps in $steps_mbps
do
        echo
        echo ">>> tcpreplay varsized cross traffic c1->c2 at $mbps Mbps for $stepduration sec"
	cmd="$tcpreplay -M${mbps}.0 $replayfile"
        echo $cmd
        $cmd &  # background it
	TCPREPLAY_PID=$!
        sleep $stepduration
	sudo kill -9 $TCPREPLAY_PID    #stop last cross-traffic run
done

