#!/bin/sh
#
# Script that generates fixed-rate cross traffic with variable-sized packets
#   uses tcpreplay and traffic snapshot of Japan-U.S. link from 
# 
# http://mawi.wide.ad.jp/
#  http://mawi.wide.ad.jp/mawi/
#   http://mawi.wide.ad.jp/mawi/samplepoint-F/20080318/
#    http://mawi.wide.ad.jp/mawi/samplepoint-F/20080318/200803201500.html
#     ftp://mawi.nezu.wide.ad.jp/pub/mawi/samplepoint-F/20080318/200803201500.dump.gz
#
# USAGE replay.sh <src> <dst> <duration> <mbps>
#
# Must be run from the current directory. WILL NOT WORK if (src != c1) and (dst != c2)
#

set -o nounset
src=$1        # ignored
dst=$2        # ignored
duration=$3   # used without modification, in seconds
mbps=$4       # expected to be an integer (fix the '-M${mbps}.0' line below otherwise)

tcpreplay="sudo /proj/MediaNet/tagent/jmccann/tagent/tools/bin/tcpreplay -i `devto x1` "
replayfile="/proj/MediaNet/tagent/jmccann/traces/jp-us.rewritten.c1-x1-c2.line-cross3.pcap.split.0.fixed"

echo
echo ">>> tcpreplay varsized cross traffic c1->c2 at $mbps Mbps for $duration seconds"
cmd="$tcpreplay -M${mbps}.0 $replayfile"
echo $cmd
$cmd &  # background it
TCPREPLAY_PID=$!
sleep $duration
sudo kill -9 $TCPREPLAY_PID    #stop last cross-traffic run

