#!/bin/sh
#
# Script that generates UDP cross traffic using trafgen.
#
# Trafgen sends commands to the local estimators which
# actually generate the traffic.
#
# USAGE step1.sh <src> <dst> <duration>
#
# Must be run from the current directory
#

src=$1
dst=$2
duration=$3

steps_mbps="4 8 6 8 4"
stepnum=`echo $steps_mbps | wc -w`

trafgen="../trafgen"

stepduration=`echo "$duration/$stepnum" | bc -l | awk -F. '{print $1}'`

# remove any current cross traffic session
$trafgen -P$src,$dst -z

# start a new traffic session (no traffic yet)
$trafgen -P$src,$dst -c

# generate traffic steps
for mbps in $steps_mbps
do
        echo
        echo ">>> trafgen UDP cross traffic $src->$dst at $mbps Mbps for $stepduration sec"
        $trafgen -P$src,$dst -s${mbps}M
        sleep $stepduration
done

# stop cross traffic
$trafgen -P$src,$dst -z
