/* Pavlos Papageorgiou <pavlos@eng.umd.edu> */
/* Fri Nov  2 18:14:14 EDT 2007 */

#include <stdio.h>
#include <unistd.h>

#include "libestimator.h"
#include "libsysstat.h"

/* libcommon */
#include "alog.h"

#include "estimator.h"
#include "info.h"

/* Only one thread of this kind can be launched because the
 * libsysstat library is not re-entrant.
 */
void *
est_cpuload_thread(void *arg)
{
        struct cpuload *data = (struct cpuload *)arg;
        int curr = 0;

        struct mp_stats_ratio_double *ratio = NULL;
        int ratio_num = 0;
        
        data->self = pthread_self();

        mpstat_init();
        curr = mpstat_init_current();

        ratio_num = mpstat_get_cpu_num() + 1;
        ratio = malloc(sizeof(struct mp_stats_ratio_double) * ratio_num);
        BUG_ON(ratio == NULL);

        while (1) {
                struct est_info info;

                sleep(data->report_every_period);

                est_info_mpstat_init(&info.mpstat);
                mpstat_read_stats(curr);
                mpstat_compute_interval_stats(curr, ratio, ratio_num);
                curr = mpstat_advance_current(curr);

                mpstat_downgrade_ratio_double_to_int(&ratio[0],
                                                     &info.mpstat.iratio);
                info_alloc_copy_push(&info);
        }

        free(ratio);
        return NULL;
}
