/*
 * Created on   : Sat Jul 24 12:26:09 EDT 2004
 * Created by   : Pavlos Papageorgiou <pavlos@eng.umd.edu>
 * 
 * adar.h
 *
 * Abstract dynamic array
 *
 * $Id: adar.h,v 1.5 2004/09/29 22:29:38 pavlos Exp $
 */

#ifndef __ADAR_H
#define __ADAR_H

#define ADAR_OK                 0

#define ADAR_ERROR             -1
#define ADAR_EINVAL            -2
#define ADAR_ENOMEM            -3

#include "anode.h"

typedef struct adarray {
    void **p;
    int nelem;
    bytes_free_func *free_func;
} adarray;

int adar_init(adarray *ar, int nelem, bytes_free_func *free_func);
int adar_done(adarray *ar);

int adar_expand(adarray *ar, int byelements);
int adar_shrink(adarray *ar, int byelements);
int adar_resize(adarray *ar, int nelem);

void adar_log(int level, adarray *ar);

#endif /* __ADAR_H */

