/*
 * Created on   : Wed Jun 23 10:47:48 EDT 2004
 * Created by   : Pavlos Papageorgiou <pavlos@eng.umd.edu>
 * 
 * anode.h
 *
 * Abstract node to be used by abstract data structures.
 *
 * $Id: anode.h,v 1.10 2005/06/17 23:51:29 pavlos Exp $
 */

#ifndef __ANODE_H
#define __ANODE_H

#include "bytes.h"
#include "rbufx.h"

#define ANODE_OK                1
#define ANODE_ERROR             -1

#define ANODE_FOREACH_CONTINUE  1
#define ANODE_FOREACH_BREAK     0

#define ANODE_BEFORE            -1
#define ANODE_EQUAL             0
#define ANODE_AFTER             1
#define ANODE_NOT_EQUAL         -2

#define ANODE_NOT_OWNER         0
#define ANODE_OWNER             1

typedef struct anode anode;

struct anode {
    anode *prev;
    anode *next;
    void *data;
    int data_owner;

    rbuf *rbowner;
};

anode * anode_create(void *data, int data_owner, rbuf_mgr *rbmgr);
int anode_destroy(anode *node, bytes_free_func *free_func);

int anode_destroy_data(anode *node, bytes_free_func *free_func);
int anode_assign_data(anode *node, void *data, int data_owner);

#endif /* __ANODE_H */

