/*
 * Created on   : Sun Jul 18 18:43:57 EDT 2004
 * Created by   : Pavlos Papageorgiou <pavlos@eng.umd.edu>
 * 
 * asignal.h
 *
 * Signal related routines.
 * 
 * $Id: asignal.h,v 1.7 2004/07/22 23:39:32 pavlos Exp $
 */

#ifndef __ASIGNAL_H
#define __ASIGNAL_H

#define ASIGNAL_OK              0
#define ASIGNAL_ERROR          -1
#define ASIGNAL_EHANDLER       -2

#include <signal.h>

#include "logerr.h"

typedef void (asignal_handler_func)(int);

int asignal_set_handler(int signo, int flags,
                asignal_handler_func *nfunc,
                asignal_handler_func **ofunc_p);

int asignal_select(int n, fd_set *readfds, fd_set *writefds, fd_set *exceptfds,
                struct timeval *timeout, const sigset_t *unblock_sigmask);

int asignal_block(int signum, int *was_blocked);
int asignal_unblock(int signum, int *was_blocked);

#endif /* __ASIGNAL_H */

