/*
 * Created on   : Tue Jun 15 12:34:29 EDT 2004
 * Created by   : Pavlos Papageorgiou <pavlos@eng.umd.edu>
 * 
 * bytes.c
 *
 * Useful macros and definitions for byte and bit manipulation.
 *
 * $Id: bytes.c,v 1.1 2005/04/14 02:10:32 pavlos Exp $
 */

#include "bytes.h"
#include "logerr.h"

void
bytes_log(int level, char *prefix, const void *buf, int buflen,
                char *byte_format, int bytes_perline)
{
    const uint8_t *data = buf;
    int log_total = 0;

    if (!logerr_loglevel_permits(level))
        return;

    logerr_log_more(level, LOGERR_FIRST, "%s", prefix);

    while (log_total < buflen) {
        if (log_total > 0 && log_total % bytes_perline == 0) {
            logerr_log_more(level, LOGERR_LAST, "");
            logerr_log_more(level, LOGERR_FIRST, "%s", prefix);
        }
        logerr_log_more(level, LOGERR_MIDDLE, byte_format, *data);
        data++;
        log_total++;
    }
    logerr_log_more(level, LOGERR_LAST, "");
}

