/*
 * Created on   : Tue Jun 15 12:34:29 EDT 2004
 * Created by   : Pavlos Papageorgiou <pavlos@eng.umd.edu>
 * 
 * bytes.h
 *
 * Useful macros and definitions for byte and bit manipulation.
 *
 * $Id: bytes.h,v 1.11 2005/04/14 02:10:32 pavlos Exp $
 */

#ifndef __BYTES_H
#define __BYTES_H

#include <inttypes.h>
#include <stdlib.h>
#include <strings.h>

typedef unsigned char byte;
typedef void (bytes_free_func)          (void *);

#define BIT_ONE64                       0xFFFFFFFFFFFFFFFFLL
#define BIT_ONE32                       0xFFFFFFFF
#define BIT_ONE16                       0xFFFF
#define BIT_ONE8                        0xFF

#define BYTES_HEX                       "%.2x "
#define BYTES_DEC                       "%.3u "

#define bit_test(FLAGS,BITS)            ((FLAGS) & (BITS))
#define bit_match(FLAGS,BITS)           (((FLAGS) & (BITS)) == (BITS))

#define bytes_add(buf,bytes)            ((void *)((uint8_t *)(buf) + (bytes)))
#define bytes_sub(buf,bytes)            ((void *)((uint8_t *)(buf) - (bytes)))

void bytes_log(int level, char *prefix, const void *buf, int buflen,
                char *byte_format, int bytes_perline);

#endif /* __BYTES_H */

