#include "alog.h"
#include "alist.h"

#include "stdio.h"

int print_all(void *state, void *data)
{
    printf("Value : %d\n", *(int *)data);
    return 1;
}


int
main(int argc, char **argv)
{

    int rc = 0;
    alist l;
    int i = 0;
    anode *node = NULL;
    int atmost = 0;

    rc = alist_init(&l, 0, &free);
    BUG_ON(rc);

    for (i = 0; i<10; i++) {
        int *pi = malloc(sizeof(int));
        *pi = i;
        alist_insert_last_r(&l, pi, 1);
    }

    rc = alist_foreach_r(&l, ALIST_FORWARD, ALIST_BEFORE_FIRST,
                &print_all, NULL);
    BUG_ON(rc);

    rc = alist_iterator_set(&l, ALIST_FCIRCULAR, ALIST_BEFORE_FIRST, NULL);
    BUG_ON(rc);

    atmost = 5;
    LOG("----- printing at most %d elements", atmost);
    while (atmost-- > 0 && (node = alist_iterator_next(&l)) != NULL) {
        print_all(NULL, node->data);
    }
    LOG("-----");

    if (node != NULL)
        alist_detach_node(&l, node);

    alist_remove_first_r(&l);

    atmost = 6;
    LOG("----- printing at most %d elements", atmost);
    while (atmost-- > 0 && (node = alist_iterator_next(&l)) != NULL) {
        print_all(NULL, node->data);
    }
    LOG("-----");

    alist_remove_last_r(&l);

    atmost = 10;
    LOG("----- printing at most %d elements", atmost);
    while (atmost-- > 0 && (node = alist_iterator_next(&l)) != NULL) {
        print_all(NULL, node->data);
    }
    LOG("-----");

    rc = alist_done(&l);
    BUG_ON(rc);

    printf("Done\n");

    return 0;
}

