#include "logerr.h"
#include "alist.h"
#include <unistd.h>
#include <stdio.h>

#include "stdio.h"

typedef struct thread_state {
    pthread_t thread;
    alist *plist;
    int id;
    int sleep;
} thread_state;

void
delay()
{
        long l = 0;
        for (l = 0; l < 1000000; l++);
}

int
print_one(void *data, void *state)
{
    char *str = state;

    printf("%s Value : %d\n", (str == NULL) ? "" : str, *(int *)data);
    delay();

    return 1;
}

void *
producer(void *arg)
{
    int i = 0;
    int res = 0;
    thread_state *state = arg;

    for (i = 0; i < 200; i++) {
        int *pi = malloc(sizeof(int));

        delay();
        *pi = state->id * 100000 + i;
        res = alist_insert_last_r(state->plist, pi, 1);
        logerr_str(res == ALIST_OK, "Failed to insert element");
        if (res == ALIST_OK) 
            printf("[thread %d]: Inserted element %d\n", state->id, *pi);
    }

    return NULL;
}

void *
consumer_all(void *arg)
{
    int i = 0;
    int res = 0;
    thread_state *state = arg;
    char idstr[50];

    snprintf(idstr, 50, "[thread %d]:", state->id);

    for (i = 0; i < 40; i++) {
        printf("%s Reading list elements\n", idstr);
        res = alist_foreach_r(state->plist,
                        ALIST_FORWARD, ALIST_BEFORE_FIRST,
                        &print_one,  idstr);
        logerr_str(res >= 0, "Failed to print");

        printf("%s Removing list elements\n", idstr);
        res = alist_remove_all_r(state->plist);
        logerr_str(res >= 0, "Failed to remove");
        sleep(1);

    }

    return NULL;
}

void *
consumer_one(void *arg)
{
    thread_state *state = arg;
    char idstr[50];
    int max_times = 2;
    int times = max_times;

    snprintf(idstr, 50, "[thread %d]:", state->id);

    while (times-- > 0) {

        void *data = NULL;

        printf("%s Servicing\n", idstr);

        while ((data = alist_remove_first_r(state->plist)) != NULL) {
            int *pi = data;
            printf("%s Removed list element: %d\n", idstr, *pi);
            free(pi);
            times = max_times;
        }
        printf("%s Sleeping\n", idstr);
        sleep(state->sleep);
        printf("%s Awake\n", idstr);
    }

    return NULL;
}


int
main(int argc, char **argv)
{

    int res = 0;
    alist l;

    thread_state prod1;
    thread_state prod2;
    thread_state cons1;

    res = alist_init(&l, 1, &free);
    logerr_assert_str(res == ALIST_OK, 0);

    prod1.id = 1;
    prod1.plist = &l;
    prod1.sleep = 0;

    prod2.id = 2;
    prod2.plist = &l;
    prod2.sleep = 3;

    cons1.id = 10;
    cons1.plist = &l;
    cons1.sleep = 1;

    printf("Size %d\n", sizeof(alist));
    printf("Size %d\n", sizeof(anode));

    pthread_create(&prod1.thread, NULL, &producer, &prod1);
    pthread_create(&prod2.thread, NULL, &producer, &prod2);
    pthread_create(&cons1.thread, NULL, &consumer_one, &cons1);

    pthread_join(prod1.thread, NULL);
    pthread_join(prod2.thread, NULL);
    pthread_join(cons1.thread, NULL);

    res = alist_done(&l);
    logerr_assert_str(res == ALIST_OK, 0);

    printf("Done\n");

    return 0;
}

