#include "atimer.h"
#include "logerr.h"

void
sleep_test()
{
    int total = 100000;
    int i = 0;
    int res = 0;
    struct timeval before;
    struct timeval after;
    long diff = 0;

    int zero = 0;
    int one = 0;
    int two = 0;
    int other = 0;

    i = total;
    long usec = 8;

    while (i-- > 0) {
        res = gettimeofday(&before, NULL);
        atimer_usleep(usec);
        res = gettimeofday(&after, NULL);
        atimer_timeval_usec_diff(&after, &before, &diff);
/*         atimer_timeval_log(0, "BEFORE ", &before); */
/*         atimer_timeval_log(0, "AFTER  ", &after); */
/*         logerr_log(0, "diff(%ld)", diff); */
        if (diff - usec == 0)
            zero++;
        else if (diff - usec == 1)
            one++;
        else if (diff - usec == 2)
            two++;
        else
            other++;
    }

    logerr_log(0, "deviation: zero(%.2d%%) one(%.2d%%) two(%.2d%%) other(%2.2f%%)",
                100 * zero / total,
                100 * one / total,
                100 * two / total,
                100.0 * other / total);
}

int
main (int argc, char **argv)
{
    sleep_test();
    exit(0);
}


