#include <stdio.h>

#include "asys.h"
#include "alog.h"

#define NUM_OF_STRINGS          10
#define MAX_NUM_OF_ARGS         10

int next_string_input = 0;
int use_stdin = 0;

// last string pointer must be NULL
char *string_inputs[] = {
        "-one -two -three",
        "-one -two -three ",
        "  -one -two -three ",
        "  -one     -two    -three",
        NULL
};

int
get_next_str_stdin(char *str, int strmax)
{
        return (fgets(str, strmax, stdin) != NULL);
}

int
get_next_str_input(char *str, int strmax)
{
        char *src = string_inputs[next_string_input];

        if (src == NULL)
                return 0;
        
        strncpy(str, src, strmax);
        next_string_input++;
        return 1;
}

int
get_next_str(char *str, int strmax)
{
        if (use_stdin)
                return get_next_str_stdin(str, strmax);
        else
                return get_next_str_input(str, strmax);
}

int
main(int argc, char **argv)
{
        char str[200];

        use_stdin = (argc > 1);

        while (get_next_str(str, sizeof(str))) {
                int len = strlen(str);
                struct asys_args args;

                // dirty way to remove newline
                if (len > 0 && str[len-1] == '\n')
                        str[len-1] = 0;

                asys_args_init(&args, MAX_NUM_OF_ARGS, "command");

                asys_args_append_options(&args, str);

                LOG("");
                LOG("stdin: <%s> argc %d", str, asys_args_count(str));
                asys_args_log(&args);

                asys_args_done(&args);
        }
        return 0;
}
