/* gethostbyname example */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <netdb.h>
#include <sys/socket.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>

int
main(int argc, char *argv[])
{
    struct hostent hspace;
    char hbuf[2000];
    unsigned int hbuf_len = sizeof(hbuf);

    struct hostent *hptr = NULL;
    int herror = 0;

    int use_reentrant = 1;

    char str[INET_ADDRSTRLEN];

    if (argc != 2) {
        printf("Usage: foo <host-to-resolve>\n");
        exit(1);
    }

    if (use_reentrant) {
        printf("GETHOSTBYNAME_R\n");
        gethostbyname_r(argv[1], &hspace, hbuf, hbuf_len, &hptr, &herror);

    } else {
        printf("GETHOSTBYNAME\n");
        hptr = gethostbyname(argv[1]);
        herror = h_errno;
    }

    if (hptr == NULL)
        printf("Could not resolve host '%s' : %s\n",
                argv[1], hstrerror(herror));

    else
        printf("Host %s resolves to %s\n",
                hptr->h_name,
                inet_ntop(hptr->h_addrtype,
                        hptr->h_addr_list[0],
                        str, sizeof(str)));

    return 0;
} 
