#define IDSTR               "client"
#define ACTIONSTR           "sending"

#include "ipc_ex.h"

void
client(void)
{
    int res = 0;
    int count = 0;
    uint16_t a, b;
    ipc_channel server;
    rec r;

    res = ipc_create_fifo(FIFO_SEND, 0700, IPC_CREATE|IPC_USE_EXISTING);
    logerr_fatal_str(res == IPC_OK, "client failed");

    res = ipc_create_fifo(FIFO_RECV, 0700, IPC_CREATE|IPC_USE_EXISTING);
    logerr_fatal_str(res == IPC_OK, "client failed");

    res = ipc_init(&server);
    logerr_fatal_str(res == IPC_OK, "client failed");

    res = ipc_open_write_fifo(&server, FIFO_SEND, 1, 1);
    logerr_fatal_str(res == IPC_OK, "client failed");

    count = 5;
    a = 100;
    b = 1;
    while (count-- > 0) {
        a += 100;
        b += 1;
        fill(&r, a, b);
        prec(&r);
        res = ipc_send(&server, &r, sizeof(rec));
        logerr_fatal_str(res <= 0, "client failed");
        sleep(CLIENT_SLEEP);
    }

    res = ipc_done(&server);
    logerr_fatal_str(res == IPC_OK, "client failed");
}

int
main(void)
{
    printf("Begin %s\n", IDSTR);

    client();

    printf("Done\n");
    return 0;
}

