#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>

#include "ipc.h"
#include "logerr.h"
#include "bytes.h"
#include "asignal.h"

#define FIFO_SEND           "/tmp/foo.send"
#define FIFO_RECV           "/tmp/foo.recv"

#define SIZE            16
#define STR_SIZE        10000

#define CLIENT_SLEEP    3
#define SERVER_SLEEP    0

typedef struct rec_A {
    uint16_t a;
    uint16_t b;
} rec_A;

typedef struct rec_B {
    char comment[STR_SIZE];
} rec_B;

typedef struct rec_C {
    uint16_t ar[SIZE];
} rec_C;

typedef struct rec {
    rec_A ra;
    rec_B rb;
    rec_C rc;
} rec;

typedef struct rec_bottom {
    rec_B rb;
    rec_C rc;
} rec_bottom;

/* yes I know it is not idempotent; just en example */

void
fill(rec *r, uint16_t a, uint16_t b) {

    int i = 0;
    int cur = 0;

    r->ra.a = a;
    r->ra.b = b;

    sprintf(r->rb.comment,
        "This is the client with a(%d) and b(%d)", r->ra.a, r->ra.b);

    cur = r->ra.a;
    for (i = 0; i< SIZE; i++) {
        r->rc.ar[i] = cur;
        cur += r->ra.b;
    }
}

void
prec_parts(rec_A *a, rec_B *b, rec_C *c)
{
    int i = 0;

    fprintf(stderr, "%s: %s record:\n    a(%d) b(%d)\n", IDSTR, ACTIONSTR,
                        a->a, a->b);
    
    b->comment[STR_SIZE-1] = 0;

    fprintf(stderr, "    comment: %s\n", b->comment);

    for (i = 0; i< SIZE; i++) {
        if (i % 8 == 0)
            fprintf(stderr, "\n   ");
        fprintf(stderr, " %8d", c->ar[i]);
    }
    fprintf(stderr, "\n");
}

void
prec(rec *r)
{
    prec_parts(&r->ra, &r->rb, &r->rc);
}



