/*
 * Pavlos Papageorgiou <pavlos@cs.umd.edu>
 * Mon Oct 22 17:45:35 EDT 2007
 *
 * Parse utilities
 */

#ifndef __LIBCOMMON_PARSE_H
#define __LIBCOMMON_PARSE_H

#include "net.h"
#include "alog.h"

static inline void
parse_two_hosts_with_ports(const char *str,
			   struct sockaddr_in *addr1,
			   struct sockaddr_in *addr2,
			   int default_port)
{
	int found = 0;

	char tmp[200];
	char error[200];

	char *comma = NULL;
	char *addr1_str = NULL;
	char *addr2_str = NULL;

	strncpy(tmp, str, sizeof(tmp));
	comma = strchr(tmp, ',');

	if (comma == NULL) {
		ERR(, "no comma in '%s' between hosts", str);
	}

	*comma = 0;
	addr1_str = tmp;
	addr2_str = comma + 1;

	found = net_resolve_host_port(addr1_str, addr1, error, sizeof(error));
	ERR_ON(!found, "failed to parse host:port '%s': %s", addr1_str, error);
	if (addr1->sin_port == 0)
		addr1->sin_port = htons(default_port);

	found = net_resolve_host_port(addr2_str, addr2, error, sizeof(error));
	ERR_ON(!found, "failed to parse host:port '%s': %s", addr2_str, error);
	if (addr2->sin_port == 0)
		addr2->sin_port = htons(default_port);
}
#endif
