/*
 * Created on   : Wed Oct  6 12:41:41 EDT 2004
 * Created by   : Pavlos Papageorgiou <pavlos@eng.umd.edu>
 * 
 * procman.h
 *
 * Process management functions
 * 
 * $Id: procman.h,v 1.2 2004/10/22 21:17:17 pavlos Exp $
 */

#ifndef __PROCMAN_H
#define __PROCMAN_H

#include <unistd.h>

#define PROCMAN_OK              0
#define PROCMAN_ERROR          -1
#define PROCMAN_ENOTROOT       -2


#if _POSIX_PRIORITY_SCHEDULING > 0

#include <sched.h>

#define procman_schedule_roundrobin(p) \
        (procman_schedule(SCHED_RR, (p)))

#define procman_schedule_fifo(p) \
        (procman_schedule(SCHED_FIFO, (p)))

int procman_schedule(int policy, int priority);

#else  /* _POSIX_PRIORITY_SCHEDULING */

#define procman_schedule_roundrobin(p)  ((void)0)
#define procman_schedule_fifo(p)        ((void)0)
#define procman_schedule(p,pr)          ((void)0)

#endif /* _POSIX_PRIORITY_SCHEDULING */


#if _POSIX_MEMLOCK > 0

#include <sys/mman.h>

#define procman_mlock_all() \
        (procman_mlock_this(MCL_CURRENT|MCL_FUTURE, NULL, 0))

#define procman_mlock_allfuture() \
        (procman_mlock_this(MCL_FUTURE, NULL, 0))

#define procman_mlock_allcurrent() \
        (procman_mlock_this(MCL_CURRENT, NULL, 0))

int procman_mlock_this(int flags, const void *addr, size_t len);

#else  /* _POSIX_MEMLOCK */

dsdd

#define procman_mlock_all()             ((void)0)
#define procman_mlock_allfuture()       ((void)0)
#define procman_mlock_allcurrent()      ((void)0)
#define procman_mlock_this(f,a,l)       ((void)0)

#endif /* _POSIX_MEMLOCK */

#endif /* __PROCMAN_H */

