#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <string.h>
#include <unistd.h>

#include "mgrp/bhtp.h"
#include "mgrp/udpex.h"

#include "probe.h"

int
probe_send_train(int sock, int pkts, int gap, int len)
{
	struct udpex_probe *probe = NULL;
	struct cmsghdr *cmsg = NULL;
	int i = 0;

	struct {
		int index;
	} payload;

	struct iovec iov = {
		.iov_base = (void *)&payload,
		.iov_len = sizeof(payload),
	};

	char ctrl[CMSG_SPACE(sizeof(struct udpex_probe))];

	struct msghdr msg = {
		.msg_name = NULL,
		.msg_namelen = 0,
		.msg_iov = &iov,
		.msg_iovlen = 1,
		.msg_control = (void *)ctrl,
		.msg_controllen = sizeof(ctrl),
		.msg_flags = 0,
	};

	int padding =  len - sizeof(payload);

	memset(&payload, 0, sizeof(payload));
	memset(ctrl, 0, sizeof(ctrl));

	cmsg = CMSG_FIRSTHDR(&msg);
	cmsg->cmsg_level = SOL_MGRP;
	cmsg->cmsg_type = UDPEX_PROBE;
	cmsg->cmsg_len = CMSG_LEN(sizeof(struct udpex_probe));

	probe = (struct udpex_probe *)CMSG_DATA(cmsg);

	for (i = 0; i < pkts; i++) {
		int size = 0;

		/* ancillary data */
		/* barrier is down for all packets except last */
		probe->barrier = (i != pkts-1);
		probe->gap_usec = gap;
		probe->pad = padding;

		/* payload */
		payload.index = i;

		/* the train actually leaves with the last sendmsg */
		size = sendmsg(sock, &msg, 0);
		if (size != sizeof(payload))
			return i;

		/* after sendmsg returns the train has been sent */
	}

	return pkts;
}


