/*
 * rate.h	Log utilities
 *
 * Created:	Tue Oct  4 16:24:50 EDT 2005
 *
 * Author:	Pavlos Papageorgiou <pavlos@eng.umd.edu>
 *
 */

#ifndef _RATE_H
#define _RATE_H

#include "tick.h"

typedef struct rate rate;
struct rate {
	struct timeval total_begin;
	uint64_t total_bytes;

	struct timeval seg_begin;
	uint64_t seg_bytes;
};

void rate_init(rate *r);
void rate_reset_total(rate *r);
void rate_reset_seg(rate *r, struct timeval *now);
void rate_report_seg(rate *r, int reset, FILE *fd, char *prefix);
void rate_report_total(rate *r, FILE *fd, char *prefix);

static inline void
rate_update_seg(rate *r, int bytes)
{
	r->total_bytes += bytes;
	r->seg_bytes += bytes;

}

static inline long long
rate_elapsed_seg(rate *r) {
	return tick_now_udiff_past(&r->seg_begin, NULL);
}

#endif /* _RATE_H */
