/*
 * Created:	Tue Apr 24 10:53:30 MDT 2007
 *
 * Author:	Pavlos Papageorgiou <pavlos@eng.umd.edu>
 *
 */

#include <netinet/tcp.h>
#include "mgrp/bhtp.h"
#include "mgrp/tcp.h"

static inline void
tsocket_activate_tcp_over_mgrp(int s)
{
	int rc = 0;
	int on = 0;
	int mss = 0;
	int fraglen = 0;

	mss = 1250;
	rc = setsockopt(s, IPPROTO_TCP, TCP_MAXSEG, &mss, sizeof(mss));
	if (rc)
		goto error;

	on = 1;
	rc = setsockopt(s, IPPROTO_TCP, TCP_MGRP, &on, sizeof(on));
	if (rc)
		goto error;

	on = 1;
	rc = setsockopt(s, SOL_MGRP, TCP_MGRP_FRAGMENT, &on, sizeof(on));
	if (rc)
		goto error;

	fraglen = 1270;
	rc = setsockopt(s, SOL_MGRP, TCP_MGRP_FRAG_LEN_MAX, &fraglen, sizeof(fraglen));
	if (rc)
		goto error;

	printf("\nsocket %d: enabled TCP over MGRP\n", s);
	return;

error:
	printf("error %d: %s\n", rc, strerror(rc));

}


