/* Must come before log.h. Otherwise we get compiler warning  */
#define LOG_PREFIX "log: "
#include "log.h"

/* assumes dest port 9090 = 0x2382 (= 0x8223 network order) */
/* timestamp option ON */

#define PORTA	0x23
#define PORTB	0x82

unsigned char tcphdr_test[24] = {
/*		    port 9090 */
	0x00, 0x00, PORTA, PORTB,
	0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00,
/*	NOP   NOP   kind  len : timestamp option */
	0x01, 0x01, 0x08, 0x0a,
};

unsigned char tcphdr_test_mustbezero[24] = {
	0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00,
/*	 		  URGENT pointer */
	0x00, 0x00, 0x00, 0xff,
	0x00, 0x00, 0x00, 0x00,
};

#define CHECK_LEN	(sizeof(tcphdr_test))


static inline int
log_tcphdr_matches_buf(unsigned char *buf, int buflen)
{
	int i = 0;

	if (buflen < CHECK_LEN)
		return 0;

	for (i = 0; i < CHECK_LEN; i++) {
		if (tcphdr_test_mustbezero[i]) {
			if (buf[i] != 0)
				return 0;
		} else if (tcphdr_test[i] == 0) {
			continue;
		} else {
			if (buf[i] != tcphdr_test[i])
				return 0;
		}
	}
	return 1;
}

int
log_tcphdr_count(unsigned char *buf, int buflen)
{
	int i = 0;
	int hdrs = 0;

	if (buflen < CHECK_LEN)
		return 0;

/* 	log_print_buf_bytes(buf, CHECK_LEN); */
	while (i < buflen - CHECK_LEN) {
		if (i >= 3 && buf[i-1] == PORTA && buf[i] == PORTB) {
			DEBUG("    possible match at %d", i);
			hdrs += log_tcphdr_matches_buf(buf+i-3, CHECK_LEN);
		}
		i++;
	}
	return hdrs;
}
