/*
 * MGRP		Measurement Manager Protocol
 *
 * Pavlos Papageorgiou <pavlos@cs.umd.edu>
 * Mon Feb  4 08:05:06 MST 2008
 *
 * Common header file (both userspace and kernel)
 */

#ifndef __MGRP_COMMON_H
#define __MGRP_COMMON_H

/* FIXME: HACK: XXX:
 *
 * IPPROTO_XXX should be be defined in linux/in.h 
 * SOL_XXX should be be defined in linux/socket.h 
 *
 * see also 'man getprotoent'
 */
#define IPPROTO_MGRP		254
#define SOL_MGRP		254

/* FIXME: this is a duplicate entry; normally defined in include/linux/tcp.h */
/* 	  To be used in setsockopt() from user-space to turn TCP over MGRP */
/* 	  (see tsocket.c) */
#define TCP_MGRP	99

/* for do_tcp_bhtp_setsockopt() and do_tcp_bhtp_getsockopt() */
#define TCP_MGRP_FRAGMENT		1
#define TCP_MGRP_FRAG_LEN_MAX		2

// XXXX temporary because cyclone code does not find it
// it is in netinet/tcp.h
#define TCP_MAXSEG 2

// XXX hardcoded because cyclone complains if I use sizeof(struct ..):
// XXX          '..has kind A but as used here needs kind TM'
// XXX no clue what this error means; hardcoding instead
#define SIZEOF_TCPHDR   20
#define SIZEOF_IPHDR    20
#define SIZEOF_MGRPHDR  16
#define SIZEOF_FRAGHDR   8

#endif
