/*
 * BHTP		Bottom Half Transport Protocol
 *
 * Created:	Tue Nov  7 13:02:09 MST 2006
 *
 * Author:	Pavlos Papageorgiou <pavlos@eng.umd.edu>
 *
 */

#ifndef _RCERR_H
#define _RCERR_H

#include <linux/kernel.h>
#include <linux/errno.h>

struct rcentry {
	int valid;
	char repr[25];
	char desc[80];
};

struct rcentry *rc2entry(int rcerrno, struct rcentry *entry);

static inline char *
rc2str(int rc, char *str, int len)
{
	struct rcentry entry = {.valid = 0};

	/* rc values are -errno */
	rc = -rc;
	rc2entry(rc, &entry);

	if (entry.valid)
		snprintf(str, len, "%s(%d): %s", entry.repr, rc, entry.desc);
	else
		snprintf(str, len, "ERRNO(%d): unknown error", rc);
	return str;
}

#endif
