/*************************************************************************

 defs.h
 Copyright (C) 2006, Norbert Vegh
 Norbert Vegh, ntools@norvegh.com

 This program is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 2 of the License, or (at your
 option) any later version.

*************************************************************************/

#ifndef DEFS_H
#define DEFS_H

#define DEF_SPORT 8888  // the default source port
#define DEF_DPORT 9999  // the default destination port
#define DEF_WINDOW 65535  // the default TCP window size
#define DEF_FILE "distfile"  // the default distribution file
#define DEF_IF "eth0"  // the default interface
#define DEF_WAIT 1000  // the default waiting time, 1s
#define MAX_RATE 1000000000  // the maximum acceptable bitrate (1 Gbps)
#define MAX_STREAMS 100  // the maximum number of streams
#define MAX_THREADS 100  // the maximum nserver/nclient threads

#define DELAY_ARR_SIZE 100000  // the array size for delay values (cjitter and filejitter)

#define OVERHEAD 52
// the TCP/IP overhead, on linux it is 52 bytes because of the TCP timestamp option

#define MAX_ARRSIZE 1000
// the max size of the distarr used for generating the weighted random file sizes

#define MAX_FILESIZES 100
// the maximum number of file sizes processed from the distribution file

#define TCP_TIMEOUT 60000000
// if the connection is idle for 1 minute, we clear the connection 

#define TCP_TIMEWAIT	0  // we clear closed streams immediatelly

const char VERSION[] = "v1.4";

#endif
