/*************************************************************************

 statistics.h
 Copyright (C) 2006, Norbert Vegh
 Norbert Vegh, ntools@norvegh.com

 This program is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the
 Free Software Foundation; either version 2 of the License, or (at your
 option) any later version.

*************************************************************************/
 
#ifndef STATISTICS_H
#define STATISTICS_H 

#include <vector>

using namespace std;

class Statistics
{
 public:
	unsigned long packets;
	unsigned long bytes;
	unsigned long losses;
	unsigned long misorderings;
	float delay;
	unsigned long minDelay;
	unsigned long maxDelay;
	int invalid;  // indicates that the delay values are invalid
	
	Statistics();
	~Statistics();
	void clear();
	void addDelay( unsigned long delay );
	unsigned long getPercentile( float p );
	
 private:
	vector<unsigned long> arr;
	int sorted;
	void heapSort();
	void siftDown( int root, int bottom );
};


#endif

